Attribute VB_Name = "TCTTools"
Option Explicit

Type Serie
    Vg1 As Single
    Vg2 As Single
    Tb() As Single
End Type

Type TDFProperties
    File As String      'Full path of the .tdf file
    Vg1Start As Single
    Vg1Stop As Single
    Vg1Pitch As Single
    Vg1Steps As Integer
    Vg1List() As Single
    Vg2List() As Single
    Vg2Start As Single
    Vg2Stop As Single
    Vg2Pitch As Single
    Vg2Steps As Integer
    VaMax As Single
    IaMax As Single
    Vg2Max As Single
    Ig2Max As Single
    Series() As Serie   'As much as  Vg1 *Vg2 pairs
    Loaded As Boolean
End Type

Public TdfLoaded(0 To 4) As TDFProperties

Type VglistLoaded
    g1 As String
    g2 As String
End Type

Public Vglistsloaded(0 To 4) As VglistLoaded

Type NSEW  'To store 4 segments around working point
    Vg As Single
    Vgnext As Single
    North(0 To 3) As Single
    South(0 To 3) As Single
    West(0 To 3) As Single
    East(0 To 3) As Single
End Type

Public TDF0 As TDFProperties

Public Const VACOL = 0, IACOL = 1, VG1COL = 2, IG1COL = 3, VG2COL = 4, IG2COL = 5

Global LastVg1 As Single

Function GetTDFProperties(Properties As TDFProperties) As Boolean
'Fill up the TDFProperties structure.
'File member must be initialized
'Returns True if succeeds

Dim S As String
Dim Slen As Single
Dim CurPos As Single
Dim LineLen As Single
Dim Started As Boolean
'Dim NewLoc As Integer
Dim Record As Integer
Dim F As Integer
Dim T As String
Dim I As Integer
Dim J As Integer
Dim K As Integer
Dim CurVg1 As Single
Dim CurVg2 As Single

    F = IsOpen(Properties.File, "R", 10)
    If F <> 0 Then
        S = Input(LOF(F), F)
        Slen = LOF(F)
        XClose F, 10
    Else
        Exit Function   'Error
    End If
    With Properties
    .Loaded = False
    .Vg1Pitch = 0   'Clean up previus data
    .Vg2Pitch = 0
    .Vg1Steps = 1
    .Vg2Steps = 1
    .IaMax = 0
    .Ig2Max = 0
    .VaMax = 0
    .Vg2Max = 0
    ReDim .Vg1List(0)
    ReDim .Vg2List(0)
    CurPos = 1
    I = 1
    ReDim .Series(0)    '.Tb(0 To 5, 0)
    ReDim .Series(0).Tb(0 To 5, 0)
Started = True
    
    Do
        I = 0
        LineLen = InStr(CurPos + 1, S, vbCrLf) - CurPos
        T = mid(S, CurPos, LineLen)
        If Len(T) Then 'If the file is not empty
            CurVg1 = Val(Substring(T, 3, " "))
            If CurVg1 = 0 Then
                Beep
            End If
            If CurVg1 > .Vg1Start Then .Vg1Start = CurVg1
            If CurVg1 < .Vg1Stop Then .Vg1Stop = CurVg1
            CurVg2 = Val(Substring(T, 5, " "))
            If CurVg2 > .Vg2Start Then .Vg2Start = CurVg2
            If CurVg2 < .Vg2Stop Then .Vg2Stop = CurVg2
            If Started Then
                For K = 0 To UBound(.Series, 1)     'Search for already existing serie
                    If .Series(K).Vg1 = CurVg1 And .Series(K).Vg2 = CurVg2 Then ' Yes, add data into.
                        Record = UBound(.Series(K).Tb, 2)   ' + 1
                        For I = 0 To 5
                            .Series(K).Tb(I, Record) = Val(Substring(T, I + 1, " "))
                        Next I
                        ReDim Preserve .Series(K).Tb(0 To 5, Record + 1)
                    End If
                Next K
            End If
            If I = 0 Then   'nothing stored, do.
                ReDim Preserve .Series(K)   ' Create a new serie to receive data
                ReDim .Series(K).Tb(0 To 5, 0)
                Record = UBound(.Series(K).Tb, 2)
                .Series(K).Vg1 = CurVg1
                .Series(K).Vg2 = CurVg2
                J = (UBound(.Vg1List, 1))
                If Started Then
                    For I = 0 To J
                        If CurVg1 = .Vg1List(I) Then Exit For    'Already exists, do nothing
                    Next I
                End If
                If I = J + 1 Then 'Not found, add
                    .Vg1List(J) = CurVg1  'Add in list
                    ReDim Preserve .Vg1List(I)
                End If
                J = (UBound(.Vg2List, 1))
                If Started Then
                    For I = 0 To J
                        If CurVg2 = .Vg2List(I) Then Exit For    'Already exists, do nothing
                    Next I
                End If
                If I = J + 1 Then 'Not found, add
                    .Vg2List(J) = CurVg2  'Add in list
                    ReDim Preserve .Vg2List(I)
                End If
                For I = 0 To 5
                    .Series(K).Tb(I, Record) = Val(Substring(T, I + 1, " "))
                Next I
                ReDim Preserve .Series(K).Tb(0 To 5, Record + 1)
'                If Not Started Then
'                    ReDim .Vg1List(1)
'                    ReDim .Vg2List(1)
'                    .Vg1List(0) = CurVg1
'                    .Vg2List(0) = CurVg2
'                    Started = True
'                End If
            End If
            
        Else
            Exit Function   'Error
        End If
        CurPos = CurPos + LineLen
    Loop While CurPos < Slen - 1
    For K = 0 To UBound(.Series, 1)
        SortArray .Series(K).Tb, 0, 2   'Records must be in Ua ascending order
    Next K
'    Debug.Print
'    For K = 0 To UBound(.Vg1List, 1)
'        Debug.Print .Vg1List(K),
'    Next K
'    Debug.Print
'    For K = 0 To UBound(.Vg2List, 1)
'        Debug.Print .Vg2List(K),
'    Next K
    SortList .Vg1List, 2
    SortList .Vg2List, 2
    .Vg1Steps = UBound(.Vg1List, 1)
    .Vg2Steps = UBound(.Vg2List, 1)
    If .Vg1Steps > 0 Then
        .Vg1Pitch = .Vg1List(1) - .Vg1List(0)
    End If
    If .Vg2Steps Then .Vg2Pitch = .Vg2List(0) - .Vg2List(1)
    .Loaded = True
    End With
    GetTDFProperties = True
End Function

Function SelectRecords(TbIn() As Single, Column As Integer, Value As Single, Tolerance As Single, TbOut() As Single) As Integer
'Fill TbOut with matching records found in TbIn
'Returns the number of matches.

Dim I As Integer
Dim CC As Integer
Dim C As Integer
Dim Found As Integer
Dim V As Single

    CC = UBound(TbIn, 1)
    If CC < Column Then Exit Function  'not that column
    ReDim TbOut(0 To CC, 0 To Found)
    Tolerance = Tolerance + 1
    For I = 0 To UBound(TbIn, 2)
        V = TbIn(Column, I)
        If Value = V Or ((Value * Tolerance) > V And (Value / Tolerance) < V) Then   'Match
            ReDim Preserve TbOut(0 To CC, 0 To Found)
            For C = 0 To CC
                TbOut(C, Found) = TbIn(C, I)
            Next C
            Found = Found + 1
        End If
    Next I
    SelectRecords = Found
End Function

Function NearRecord(TbIn() As Single, Column As Integer, Value As Single, TbOut() As Single) As Integer
'Put the nearest matching record in TbOut
'Returns index where found in TbIn

Dim I As Integer
Dim J As Integer
Dim F As Integer
Dim Delta As Single

    ReDim TbOut(5, 0)
    Delta = 3.402823E+38    'Upper limit
    For I = 0 To UBound(TbIn, 2)
        If Abs(Value - TbIn(Column, I)) < Abs(Delta) Then
            Delta = Abs(Value - TbIn(Column, I))
            F = I
        End If
    Next I
    Delta = Delta / (1 + Value)    'Voids division by 0
    For I = 0 To 5
        TbOut(I, 0) = TbIn(I, F)
    Next I
    NearRecord = F
End Function

Function BetweenRecords(TbIn() As Single, StartAtRecord As Integer, Column As Integer, Value As Single, TbOut() As Single) As Integer
'Put a record whith values interpolated if not exact match found.
'Returns the record's (line) number where the match occured, 0 if not found.

Dim TbTemp() As Single
Dim I As Integer
Dim C As Integer
Dim V As Single
Dim Step As Single
Dim K As Single

    TbTemp = TbIn    'Preserve TbIn
    If StartAtRecord < 0 Then StartAtRecord = 0
    For I = StartAtRecord To UBound(TbTemp, 2)
        V = TbTemp(Column, I)
        If V >= Value Then
            BetweenRecords = I
            ReDim TbOut(5, 0)                   'Setup output
            For C = 0 To 5
                TbOut(C, 0) = TbTemp(C, I)      'Copy record
            Next C
            If V = Value Then Exit Function     'Exact match or first ! Done.
            If I > 0 Then                       'Interpolate with previous record
                Step = TbOut(Column, 0) - TbTemp(Column, I - 1)
                K = V - Value
                K = Step / K
'                Debug.Print "BetweenRecords:K= "; K
                For C = 0 To 5
'                    Debug.Print TbOut(C, 0);
                    TbOut(C, 0) = TbOut(C, 0) - (TbOut(C, 0) - TbTemp(C, I - 1)) / K
'                    TbOut(C, 0) = (TbOut(C, 0) + TbTemp(C, I - 1)) / K
'                    Debug.Print TbOut(C, 0);
'                    If C <> VG1COL And K > 0 Then TbOut(C, 0) = TbOut(C, 0) - (TbOut(C, 0) - TbTemp(C, I - 1)) / K
                Next C
'                Debug.Print
                Exit Function
            End If
        End If
    Next I
    BetweenRecords = 0  'Not found
End Function

Function GetVg1Serie(Tdf As TDFProperties, Ia As Single, Va As Single, Found As Serie, R As Single) As Boolean

    If GetNextVg1Serie(Tdf, Ia, Va, Found, R) Then
'        GetVg1Serie = GetPrevVg1Serie(Tdf, Ia, Va, Found, R)
    End If
End Function

Function GetNextVg1Serie(Tdf As TDFProperties, Ia As Single, Va As Single, Found As Serie, R As Single) As Boolean
'Returns the Vg1 serie

Dim I As Integer
Dim J As Integer
Dim K As Integer
Dim L As Integer
Dim Vg1 As Single
Dim dI As Single
Dim dV As Single

    With Tdf
    For I = 0 To .Vg1Steps
        Vg1 = .Vg1List(I)
        For J = 0 To UBound(.Series, 1)
            If .Series(J).Vg1 = Vg1 Then
                For K = 0 To UBound(.Series(J).Tb, 2)
                    If .Series(J).Tb(IACOL, K) >= Ia And .Series(J).Tb(VACOL, K) <= Va Then
                        Found = .Series(J)
                        dI = .Series(J).Tb(IACOL, K) - .Series(J).Tb(IACOL, K - 1)
                        dV = .Series(J).Tb(VACOL, K) - .Series(J).Tb(VACOL, K - 1)
                        R = dV / dI
'                        Base.MoveMarker .Series(J).Tb(IACOL, K), .Series(J).Tb(VACOL, K)
                        For L = K To UBound(.Series(J).Tb, 2)
                            If .Series(J).Tb(VACOL, L) >= Va Then
                                Base.MoveMarker .Series(J).Tb(IACOL, L), .Series(J).Tb(VACOL, L)
                                Exit For
                            End If
                        Next L
                        GetNextVg1Serie = True
                        Exit Function
                    End If
                Next K
            End If
        Next J
    Next I
    End With
End Function
Function GetPrevVg1Serie(Tdf As TDFProperties, Ia As Single, Va As Single, Found As Serie, R As Single) As Boolean
'Returns the Vg1 serie

Dim I As Integer
Dim J As Integer
Dim K As Integer
Dim Vg1 As Single
Dim dI As Single
Dim dV As Single

    With Tdf
    For I = 0 To .Vg1Steps
        Vg1 = .Vg1List(I)
        For J = 0 To UBound(.Series, 1)
            If .Series(J).Vg1 = Vg1 Then
                For K = 0 To UBound(.Series(J).Tb, 2)
                    If .Series(J).Tb(IACOL, K) >= Ia And .Series(J).Tb(VACOL, K) >= Va Then
                        Found = .Series(J)
                        dI = .Series(J).Tb(IACOL, K) - .Series(J).Tb(IACOL, K - 1)
                        dV = .Series(J).Tb(VACOL, K) - .Series(J).Tb(VACOL, K - 1)
                        R = dV / dI
                        Base.MoveMarker .Series(J).Tb(IACOL, K), .Series(J).Tb(VACOL, K)
                        GetPrevVg1Serie = True
                        Exit Function
                    End If
                Next K
            End If
        Next J
    Next I
    End With
    
End Function

Function Interpolate(U0 As Single, I0 As Single, U1 As Single, I1 As Single, X As Single) As Single
Dim dU As Single
Dim dI As Single
Dim R As Single

    dU = U1 / U0
    dI = I1 / I0
    R = 1000 * dU / dI  ' Pourquoi ce coeff 1000 ? ?
    Interpolate = U0 + R * (X - I0)
End Function

Function BFg1g2Serie(Tdf As TDFProperties, Vg1 As Single, Vg2 As Single) As Serie
Dim I As Integer
Dim J As Integer
Dim Kg1 As Single
Dim Kg2 As Single

    With Tdf
        For J = 0 To UBound(.Vg1List, 1)
            Debug.Print .Vg1List(J),
        Next J
        Debug.Print
        For I = 0 To UBound(.Series, 1)
            Debug.Print I, .Series(I).Vg1
'            If .Series(I).Vg1 >= Vg1 Then 'And .Series(I).Vg2 >= Vg2 Then     'Found exact or higher
'                Kg1 = .Series(I).Vg1 - Vg1
'                Kg2 = .Series(I).Vg2 - Vg2
'                Debug.Print
'                Debug.Print I, .Series(I).Vg1, Kg1, .Series(I).Vg2, Kg2
'                If I < UBound(.Series) Then
'                    Debug.Print I + 1, .Series(I + 1).Vg1, Kg1, .Series(I + 1).Vg2, Kg2
'                End If
'                GoTo Found
'            End If
        Next I
Found:
    End With
End Function

